/*
 * Copyright (C) 2008 Petr Hruska <phru@ucw.cz> 
 * 
 * This file is part of Cutter module.
 * 
 * Cutter module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef _BILLING_H__
#define _BILLING_H__

#include "../../str.h"

/* default billing socket */
extern const char const *default_billing_host;
extern const int default_billing_port;

extern char *billing_address; 
extern int billing_timeout; 
extern int billing_duration; 
extern char *billing_gateway; 

int parse_billing_address(char const* billing_address);

/* Allocate and free buffer for received message.
 * Output parameters of subsequent functions points into this buffer.
 */
void* billing_alloc();
void billing_free(void* buf);

int billing_calling(void* bbuf, str const* callid, str const* caller, str const* callee, str const* srcip, str* callcon, time_t* time, int* monitor, int* result);
int billing_answered(void* bbuf, str const* callid, time_t time, time_t *next_continue, int* monitor, int* result);
int billing_cancelled(void* bbuf, str const* callid, time_t time, str const* description, int* result);
int billing_continue(void* bbuf, str const* callid, time_t *next_continue, int* monitor, int* result);
int billing_hangedup(void* bbuf, str const* callid, time_t time, str const* description, int* result);


#endif
