/*
 * Copyright (C) 2008 Petr Hruska <phru@ucw.cz> 
 * 
 * This file is part of Cutter module.
 * 
 * Cutter module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#include <string.h>

#include "../../sr_module.h"

#include "misc.h"



int str2time_t(str s)
{
	time_t r = 0;
	int i = 0;
	while (i < s.len) {
		int c = s.s[i++];
		if (c < '0' || c > '9' ) return (time_t) 0;
		c -= '0';
		r = 10 * r + c;
	}

	return r;
}

inline int str2uint(str s)
{
	int r = 0;
	int i = 0;
	while (i < s.len) {
		int c = s.s[i++];
		if (c < '0' || c > '9' ) return 0;
		c -= '0';
		r = 10 * r + c;
	}

	return r;
}


int str2signed_int(str s)
{
	if (!s.len) return 0;

	if (s.s[0] == '-') {
		s.s++;
		s.len--;
		return -str2uint(s);
	}
	return str2uint(s);
}


int serstrcmp(const str* s, const str* t)
{
	//DBG("DEBUG: cutter: serstrcmp(): start.\n");
	if (!s->s) {
		return t->s ? -1 : 0;
	}
	if (!t->s) return 1;

	int len = s->len < t->len ? s->len : t->len;

	//DBG("DEBUG: cutter: serstrcmp(): len = %d.\n", len);

	int r = strncmp(s->s, t->s, len);
	//DBG("DEBUG: cutter: serstrcmp(): r = %d.\n", r);

	if (s->len != t->len) {
		if (!r)
			return s->len < t->len ? -1 : 1;
		else
			return r;
	}

	return r;
}
