/*
 * Copyright (C) 2008 Petr Hruska <phru@ucw.cz> 
 * 
 * This file is part of Cutter module.
 * 
 * Cutter module is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef _TIMER_DATA_H__
#define _TIMER_DATA_H__

#include <time.h>

struct timer_item_t {
	int dlg; // dialog id from database
	time_t t; // time of an event

	// circular linked list of items belonging to one hash value, 
	// or free (not allocated) items
	struct timer_item_t* next;
	struct timer_item_t* prev;
};



// Most of functions in this module returns 0 on success, -1 on failure and -2 on
// not found

int td_init();

//copies *pti into internal structures, pti can be safely deallocated
int td_insert(struct timer_item_t* pti);
int td_remove(int dlg);

//removes the item on top and fills *pti
int td_extract(struct timer_item_t* pti);

//removes the item on top only if ti.t >= t and fills *pti
int td_extract_elapsed(struct timer_item_t* pti, time_t t);


#endif
